# OpenVerse Objects Module 
# 
# this file initalizes the program and does any
# platform specific things/setup. It will then source 
# supporting modules.
#
# Module Name		- Objects Module
# Current Revision No.	- 0.1
# Current Maintainter 	- Cruise <cruise@drunkenbastards.org>
# Last update 		- Sun Sep  5 21:24:33 EDT 1999
# Sourced By		- Command Line
#
# Copyright (C) 1999 David Gale <cruise@openverse.org>
# For more information visit http://OpenVerse.org/
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
# USA.

proc NewObject {} {
}

proc DrawBox {name x1 y1 x2 y2 fill outline duration} {
	global MV
	
	if {[lsearch -exact $MV(server_objects) $name] != -1} {
		KillServerObject $MV(server_objects.$name.id)
	}
	lappend MV(server_objects) $name
	set id [.top.c create rectangle $x1 $y1 $x2 $y2 \
		-fill $fill -outline $outline]

	set MV(server_objects.$id.name) $name
	set MV(server_objects.$name.image) "NOT_IMAGE_COMPATABLE"
	set MV(server_objects.$name.id) $id

	if $duration {
		after $duration "KillServerObject $id"
	}
}

proc DrawImage {name x1 y1 image size duration} {
	global MV

	if {[lsearch -exact $MV(server_objects) $name] != -1} {
		set MV(server_objects.$name.image) $image
		if ![file exists "$MV(objects)/$image"] {
			if {[lsearch -exact $MV(downloads) $image] == -1} {
				SendToServer "DCCSENDOB $image"
				image create photo server_object_$name -file "$MV(icondir)/unknown.gif"
			} else {
				image create photo server_object_$name -file "$MV(icondir)/unknown.gif"
			}
		} else {
			if {$size != [file size "$MV(objects)/$image"]} {
				if {[lsearch -exact $MV(downloads) $image] == -1} {
					SendToServer "DCCSENDOB $image"
					image create photo server_object_$name -file "$MV(icondir)/unknown.gif"
				} else {
					image create photo server_object_$name -file "$MV(icondir)/unknown.gif"
				}
			} else {
				image create photo server_object_$name -file "$MV(objects)/$image"
			}
		}
		return
	}
	lappend MV(server_objects) $name

	if ![file exists "$MV(objects)/$image"] {
		if {[lsearch -exact $MV(downloads) $image] == -1} {
			SendToServer "DCCSENDOB $image"
			image create photo server_object_$name -file "$MV(icondir)/unknown.gif"
		} else {
			image create photo server_object_$name -file "$MV(icondir)/unknown.gif"
		}
	} else {
		if {$size != [file size "$MV(objects)/$image"]} {
			if {[lsearch -exact $MV(downloads) $image] == -1} {
				SendToServer "DCCSENDOB $image"
				image create photo server_object_$name -file "$MV(icondir)/unknown.gif"
			} else {
				image create photo server_object_$name -file "$MV(icondir)/unknown.gif"
			}
		} else {
			image create photo server_object_$name -file "$MV(objects)/$image"
		}
	}

	set id [.top.c create image $x1 $y1 -image server_object_$name]

	set MV(server_objects.$id.name) $name
	set MV(server_objects.$name.image) $image
	set MV(server_objects.$name.id) $id

	if $duration {
		after $duration "KillServerObject $id"
	}
}

proc DrawMouseOver {name x1 y1 image1 size1 image2 size2 duration} {
	global MV

	if {[lsearch -exact $MV(server_objects) $name] != -1} {
		if ![file exists "$MV(objects)/$image1"] {
			if {[lsearch -exact $MV(downloads) $image1] == -1} {
				SendToServer "DCCSENDOB $image1"
				image create photo server_object_$name -file "$MV(icondir)/unknown.gif"
			} else {
				image create photo server_object_$name -file "$MV(icondir)/unknown.gif"
			}
		} else {
			if {$size1 != [file size "$MV(objects)/$image1"]} {
				if {[lsearch -exact $MV(downloads) $image1] == -1} {
					SendToServer "DCCSENDOB $image1"
					image create photo server_object_$name -file "$MV(icondir)/unknown.gif"
				} else {
					image create photo server_object_$name -file "$MV(icondir)/unknown.gif"
				}
			} else {
				image create photo server_object_$name -file "$MV(objects)/$image1"
			}
		}

		if ![file exists "$MV(objects)/$image2"] {
			if {[lsearch -exact $MV(downloads) $image2] == -1} {
				SendToServer "DCCSENDOB $image2"
			}
		} else {
			if {$size2 != [file size "$MV(objects)/$image2"]} {
				if {[lsearch -exact $MV(downloads) $image2] == -1} {
					SendToServer "DCCSENDOB $image2"
				}
			}
		}
		return
	}
	lappend MV(server_objects) $name

	if ![file exists "$MV(objects)/$image1"] {
		if {[lsearch -exact $MV(downloads) $image1] == -1} {
			SendToServer "DCCSENDOB $image1"
			image create photo server_object_$name -file "$MV(icondir)/unknown.gif"
		} else {
			image create photo server_object_$name -file "$MV(icondir)/unknown.gif"
		}
	} else {
		if {$size1 != [file size "$MV(objects)/$image1"]} {
			if {[lsearch -exact $MV(downloads) $image1] == -1} {
				SendToServer "DCCSENDOB $image1"
				image create photo server_object_$name -file "$MV(icondir)/unknown.gif"
			} else {
				image create photo server_object_$name -file "$MV(icondir)/unknown.gif"
			}
		} else {
			image create photo server_object_$name -file "$MV(objects)/$image1"
		}
	}

	if ![file exists "$MV(objects)/$image2"] {
		if {[lsearch -exact $MV(downloads) $image2] == -1} {
			SendToServer "DCCSENDOB $image2"
		}
	} else {
		if {$size2 != [file size "$MV(objects)/$image2"]} {
			if {[lsearch -exact $MV(downloads) $image2] == -1} {
				SendToServer "DCCSENDOB $image2"
			}
		}
	}

	set id [.top.c create image $x1 $y1 -image server_object_$name]
	.top.c bind $id <Enter> "MouseOverEvent 1 $id"
	.top.c bind $id <Leave> "MouseOverEvent 0 $id"

	set MV(server_objects.$id.name) $name
	set MV(server_objects.$name.image) $image1
	set MV(server_objects.$name.image2) $image2
	set MV(server_objects.$name.id) $id

	if $duration {
		after $duration "KillServerObject $id"
	}
}

proc DrawText {name x1 y1 color size duration text} {
	global MV


	if {[lsearch -exact $MV(server_objects) $name] != -1} {
		.top.c itemconfigure $MV(server_objects.$name.id) -fill $color -text $text
		return
	}
	lappend MV(server_objects) $name

	set id [.top.c create text $x1 $y1 -fill $color -text $text]
	set MV(server_objects.$name.id) $id
	set MV(server_objects.$id.name) $name
	set MV(server_objects.$name.image) "NOT_IMAGE_COMPATABLE"

	if $duration {
		after $duration "KillServerObject $id"
	}
}

proc DrawLink {name x1 y1 x2 y2 duration url} {
	global MV

	if {[lsearch -exact $MV(server_links) $name] != -1} {
		KillServerLink $MV(server_links.$name.id)
	}
	lappend MV(server_links) $name

	set id [incr MV(current_link_id)]
	set MV(server_links.$name.x1) $x1
	set MV(server_links.$name.y1) $y1
	set MV(server_links.$name.x2) $x2
	set MV(server_links.$name.y2) $y2
	set MV(server_links.$name.url) $url
	set MV(server_links.$id.name) $name
	set MV(server_links.$name.id) $id
	if $duration {
		after $duration "KillServerLink $id"
	}
}

proc DrawExit {name x1 y1 x2 y2 duration host port} {
	global MV

	if {[lsearch -exact $MV(server_exits) $name] != -1} {
		KillServerExit $MV(server_exits.$name.id)
	}
	lappend MV(server_exits) $name

	set id [incr MV(current_exits_id)]
	set MV(server_exits.$name.x1) $x1
	set MV(server_exits.$name.y1) $y1
	set MV(server_exits.$name.x2) $x2
	set MV(server_exits.$name.y2) $y2
	set MV(server_exits.$name.host) $host
	set MV(server_exits.$name.port) $port
	set MV(server_exits.$id.name) $name
	set MV(server_exits.$name.id) $id
	if $duration {
		after $duration "KillServerExit $id"
	}
}

proc KillServerExit {id} {
	global MV
	set idx [lsearch -exact $MV(server_exits) $MV(server_exits.$id.name)]
	set MV(server_exits) [lreplace $MV(server_exits) $idx $idx]
}

proc KillServerLink {id} {
	global MV
	set idx [lsearch -exact $MV(server_links) $MV(server_links.$id.name)]
	set MV(server_links) [lreplace $MV(server_links) $idx $idx]
}

proc KillServerObject {id} {
	global MV

	set idx [lsearch -exact $MV(server_objects) $MV(server_objects.$id.name)]
	set MV(server_objects) [lreplace $MV(server_objects) $idx $idx]
	.top.c delete $id
}

proc MouseOverEvent {onoff id} {
	global MV

	if $onoff {
		catch {image create photo server_object_$MV(server_objects.$id.name) -file "$MV(objects)/$MV(server_objects.$MV(server_objects.$id.name).image2)"} err
	} else {
		catch {image create photo server_object_$MV(server_objects.$id.name) -file "$MV(objects)/$MV(server_objects.$MV(server_objects.$id.name).image)"}
	}
}
